package backend.hdl.arch.rewrite

import backend.hdl.arch.{ArchLambda, JoinOrderedStream, MapOrderedStream, OrderedStreamToUnorderedStream}
import core.ParamUse
import core.rewrite.{Rule, RulesT}

object MoveUpOrderedToUnorderedStreamRules extends RulesT {

  override def all(config: Option[Int]): Seq[Rule] =
    Seq(
      skipJoin
    ) ++ Seq(CleanupRules.moveUpMapOrderedToUnorderedStream, CleanupRules.replaceJoinUnorderedStream)

  def skipJoin: Rule = Rule("moveUpOrderedToUnorderedStream_skipJoin", {
    case JoinOrderedStream(MapOrderedStream(ArchLambda(p1, MapOrderedStream(ArchLambda(p2,
    OrderedStreamToUnorderedStream(ParamUse(p3), _), _), ParamUse(p4), _), _), input, _), _) if
      p1.id == p4.id && p2.id == p3.id =>
      MapOrderedStream(OrderedStreamToUnorderedStream.asFunction(), JoinOrderedStream(input))
  })
}
