package backend.hdl.arch.rewrite

import backend.hdl.arch.{ArchLambda, MapOrderedStream, ZipOrderedStream}
import core.{Expr, ParamDef, ParamUse}
import core.rewrite.{Rule, RulesT}

object MoveUpZipStreamRules extends RulesT {
  override def all(config: Option[Int]): Seq[Rule] = Seq(
    mapFusion
  )

  private def mapFusion: Rule = Rule("MoveUpZipStreamRules_mapFusion", {
    // map fusion
    case MapOrderedStream(ArchLambda(pd, body, _), MapOrderedStream(ArchLambda(p1, ZipOrderedStream(ParamUse(p2), _), _), input, _), _)
      if p1.id == p2.id &&
        (body match {
          case ZipOrderedStream(ParamUse(p3), _) if pd.id == p3.id => false
          case _ => true
        }) =>
      MapOrderedStream(
        {
          val newParam = ParamDef()
          ArchLambda(
            newParam,
            body.visitAndRebuild(
              {
                case ParamUse(usedParam) if usedParam.id == pd.id => ZipOrderedStream(ParamUse(newParam))
                case e => e
              }
            ).asInstanceOf[Expr]
          )
        },
        input
      )
  })
}
