package cGen.eqsat

import scala.collection.mutable

/**
 * The core data common to all e-graphs that use a disjoint set forest and a hash cons to store e-nodes and e-classes.
 * @tparam ENode The type of an e-node in the graph.
 * @tparam EClass The type of an e-class in the graph.
 */
class DisjointSetForestPEGData[ENode, EClass] {
  /**
   * A disjoint set forest containing all expression nodes that are being reasoned about.
   */
  val unionFind = new DisjointSetForest[EClass]()

  val hashCons = new mutable.HashMap[ENode, EClass]()
  val reasons = new mutable.HashMap[ENode, NodeReason]()
}
