package cGen.eqsat

import core.ExprVar

case class GraphRewritingInliner(body: ExprVar, arg: ExprVar) extends Applier {
  override def apply[ENode <: ENodeT, EClass <: EClassT](eGraph: EGraphT[ENode, EClass])
                                                        (rule: Rewrite,
                                                         matchInfo: Match[EClass],
                                                         stopwatch: HierarchicalStopwatch): Set[EClass] = {
    val builder = new SubgraphBuilder[ENode, EClass]()
    val rewriter = SubstitutingRewriter(eGraph, builder, List(matchInfo.instantiate(arg)))
    val promise = rewriter.rewrite(matchInfo.instantiate(body))
    val reason = AddedByRewrite(rule, matchInfo.where, matchInfo)
    val substituted = builder.transferTo(eGraph, reason, promise.asInstanceOf[builder.Promise])
    if (eGraph.merge(matchInfo.where, substituted, reason)) {
      Set(matchInfo.where)
    } else {
      Set()
    }
  }
}
