package cGen.eqsat
import core.LambdaT

case class ShiftingRewriter[ENode <: ENodeT, EClass <: EClassT](override val eGraph: EGraphT[ENode, EClass],
                                                                override val builder: SubgraphBuilder[ENode, EClass],
                                                                amount: Int) extends ParameterUseRewriter[ENode, EClass, Unit] {
  override def lambdaValue(lambda: LambdaT): Unit = ()

  override protected def initialContext(eClass: EClass): List[(Unit, Int)] = Nil

  override protected def rewriteAndAdd(node: ENode, context: List[(Unit, Int)]): builder.Promise = node.expr match {
    case use: DeBruijnParamUse if use.index >= context.length =>
      builder.add(DeBruijnParamUse(use.index + amount, use.t), Seq())

    case _ => rewriteAndAddDefault(node, context)
  }
}
