package cGen

import cGen.Isomorphic.{digest, isIsomorphic}
import cGen.primitive.Concat
import core._
import org.junit.Test

class IsomorphicTest {
  @Test
  def ParamDefUseTest() = {
    val a = ParamDef(IntType(32))
    val b = ParamDef(IntType(32))
    val c = ParamDef(IntType(64))
    assert(isIsomorphic(a, b) && digest(a) == digest(b))
    assert(isIsomorphic(ParamUse(a), ParamUse(b)) && digest(ParamUse(a)) == digest(ParamUse(b)))
    assert(!isIsomorphic(ParamUse(a), b))
    assert(digest(ParamUse(a)) != digest(b))
    assert(!isIsomorphic(a, c))
    assert(digest(a) != digest(c))
  }

  @Test
  def viewTest() = {
    val a = ParamDef(ArrayType(IntType(32), 8))
    val b = ParamDef(ArrayType(IntType(32), 8))
    val concat0 = Concat(Tuple(a, b, SrcViewType()), SrcViewType())
    val concat1 = Concat(Tuple(a, b, DestViewType()), DestViewType())
    val concat2 = Concat(Tuple(a, b, SrcViewType()), SrcViewType())
    assert(!isIsomorphic(concat0, concat1))
    assert(digest(concat0) != digest(concat1))
    assert(isIsomorphic(concat0, concat2))
    assert(digest(concat0) == digest(concat2))
  }
}
