package cGen.eqsat

import cGen.{AlgoOp, BinaryOp, Constant, IntType}
import org.junit.Test

class RelaxPatternTest {
  @Test
  def canRelaxNestedBinary(): Unit = {
    val t = IntType(32)
    val regularBinary = BinaryOp(Constant(0, t), Constant(42, t), AlgoOp.Add)
    val nestedBinary = BinaryOp(Constant(0, t), BinaryOp(Constant(10, t), Constant(20, t), AlgoOp.Mul), AlgoOp.Add)
    val graph = new DeferredMergingEGraph(
      new Willsey2021EGraph(analyses = new AnalysesBuilder().toAnalyses))
    val root = graph.add(regularBinary)
    graph.rebuild()

    val relaxedPattern = Pattern(nestedBinary).relax(graph)(root, HierarchicalStopwatch.disabled).get
    assert(ExprToText(relaxedPattern) == "0 + (expr 0)")
  }
}
